"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.getAllUsers = exports.selectedUser = exports.checkUserName = exports.getRandomUser = exports.getAllUser = exports.unSetSelecte = exports.setSelectedUser = exports.deleteUser = exports.setUser = void 0;
exports.setUser = function (db, accessToken, accessTokenSecret, userName, id) { return __awaiter(void 0, void 0, void 0, function () {
    var data, result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                data = {
                    type: 'user',
                    name: userName,
                    accessToken: accessToken,
                    accessTokenSecret: accessTokenSecret,
                    userid: id.toString(),
                    selected: true
                };
                return [4 /*yield*/, new Promise(function (resolve) {
                        db.insert(data, function (err) {
                            if (!err) {
                                resolve(true);
                                return;
                            }
                            resolve(false);
                        });
                    })];
            case 1:
                result = _a.sent();
                return [4 /*yield*/, db.loadDatabase()];
            case 2:
                _a.sent();
                return [2 /*return*/, result];
        }
    });
}); };
exports.deleteUser = function (db, id) { return __awaiter(void 0, void 0, void 0, function () {
    var result;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.remove({ _id: id }, { multi: false }, function (err) {
                        if (!err) {
                            resolve(true);
                            return;
                        }
                        resolve(false);
                    });
                })];
            case 1:
                result = _a.sent();
                return [4 /*yield*/, db.loadDatabase()];
            case 2:
                _a.sent();
                return [2 /*return*/, result];
        }
    });
}); };
exports.setSelectedUser = function (db, name) { return __awaiter(void 0, void 0, void 0, function () {
    var data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.update({
                        name: name
                    }, {
                        $set: {
                            selected: true
                        }
                    }, {}, function (error) {
                        if (!error) {
                            resolve(true);
                            return;
                        }
                        resolve(false);
                    });
                })];
            case 1:
                data = _a.sent();
                return [4 /*yield*/, db.loadDatabase()];
            case 2:
                _a.sent();
                return [2 /*return*/, data];
        }
    });
}); };
exports.unSetSelecte = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var data;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.update({
                        selected: true
                    }, {
                        $set: {
                            selected: false
                        }
                    }, {
                        multi: true
                    }, function (error) {
                        if (!error) {
                            resolve(true);
                            return;
                        }
                        resolve(false);
                    });
                })];
            case 1:
                data = _a.sent();
                return [4 /*yield*/, db.loadDatabase()];
            case 2:
                _a.sent();
                return [2 /*return*/, data];
        }
    });
}); };
exports.getAllUser = function (db) {
    return new Promise(function (resolve) {
        db.find({}, function (err, result) {
            if (!err && result) {
                resolve(result);
            }
            else {
                resolve([]);
            }
        });
    });
};
exports.getRandomUser = function (db) {
    return new Promise(function (resolve) {
        db.findOne({}, function (err, result) {
            if (!err && result) {
                resolve(result);
            }
            else {
                resolve({});
            }
        });
    });
};
exports.checkUserName = function (db, name) {
    return new Promise(function (resolve) {
        db.findOne({ name: name }, function (err, result) {
            if (!err && result) {
                resolve(true);
            }
            else {
                resolve(false);
            }
        });
    });
};
exports.selectedUser = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var user;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.findOne({ selected: true }, function (err, result) {
                        if (!err && result) {
                            resolve(result);
                        }
                        else {
                            resolve({});
                        }
                    });
                })];
            case 1:
                user = _a.sent();
                db.loadDatabase();
                return [2 /*return*/, user];
        }
    });
}); };
exports.getAllUsers = function (db) { return __awaiter(void 0, void 0, void 0, function () {
    var user;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, new Promise(function (resolve) {
                    db.find({}, function (err, result) {
                        if (!err && result) {
                            resolve(result);
                        }
                        else {
                            resolve([]);
                        }
                    });
                })];
            case 1:
                user = _a.sent();
                db.loadDatabase();
                return [2 /*return*/, user];
        }
    });
}); };
