"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var prompts_1 = __importDefault(require("prompts"));
var fs_1 = __importDefault(require("fs"));
var console_1 = __importDefault(require("./console"));
var db_1 = require("./db");
var deleteSelectedUser = function (db, id, userName) { return __awaiter(void 0, void 0, void 0, function () {
    var result, checkUser, name;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, db_1.deleteUser(db, id)];
            case 1:
                result = _a.sent();
                if (!result) return [3 /*break*/, 6];
                console.log(console_1["default"].green('✔') + " " + userName + "\u304B\u3089\u30ED\u30B0\u30A2\u30A6\u30C8\u3057\u307E\u3057\u305F");
                return [4 /*yield*/, db_1.selectedUser(db)];
            case 2:
                checkUser = _a.sent();
                if (!!Object.keys(checkUser).length) return [3 /*break*/, 5];
                return [4 /*yield*/, db_1.getRandomUser(db)];
            case 3:
                name = (_a.sent()).name;
                return [4 /*yield*/, db_1.setSelectedUser(db, name)];
            case 4:
                if (_a.sent()) {
                    console.log(console_1["default"].green('✔') + " \u73FE\u5728\u306E\u30E6\u30FC\u30B6\u30FC\u306F" + name + "\u3067\u3059");
                    return [2 /*return*/, true];
                }
                throw new Error('database設定時にエラーがあったようです...もう一度ログインを試してみてください');
            case 5: return [2 /*return*/, true];
            case 6: throw new Error('database削除時にエラーがあったようです...もう一度ログインを試してみてください');
        }
    });
}); };
var selectedDeleteUser = function (selected) { return __awaiter(void 0, void 0, void 0, function () {
    var onCancel, user;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                onCancel = function () {
                    throw new Error('選択されませんでした');
                };
                return [4 /*yield*/, prompts_1["default"]([
                        {
                            type: 'select',
                            name: 'user',
                            message: '削除したいアカウントを選択してください',
                            choices: selected
                        }
                    ], { onCancel: onCancel })];
            case 1:
                user = (_a.sent()).user;
                return [2 /*return*/, user];
        }
    });
}); };
var createSelectedArray = function (users) {
    var selectArray = [
        {
            title: 'all',
            value: { type: 'all' }
        }
    ];
    for (var i = 0; i < users.length; i += 1) {
        selectArray.push({
            title: users[i].name,
            value: {
                type: 'user',
                id: users[i]._id,
                name: users[i].name
            }
        });
    }
    return selectArray;
};
var Logout = function (db, path) { return __awaiter(void 0, void 0, void 0, function () {
    var users, selectedArray, _a, type, id, name, err_1;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                _b.trys.push([0, 6, , 7]);
                return [4 /*yield*/, db_1.getAllUser(db)];
            case 1:
                users = _b.sent();
                return [4 /*yield*/, createSelectedArray(users)];
            case 2:
                selectedArray = _b.sent();
                return [4 /*yield*/, selectedDeleteUser(selectedArray)];
            case 3:
                _a = _b.sent(), type = _a.type, id = _a.id, name = _a.name;
                if (type === 'all') {
                    fs_1["default"].unlinkSync(path);
                    console.log(console_1["default"].green('✔') + " \u5168\u3066\u306E\u30A2\u30AB\u30A6\u30F3\u30C8\u3092\u524A\u9664\u3057\u307E\u3057\u305F");
                    return [2 /*return*/];
                }
                if (!type) return [3 /*break*/, 5];
                return [4 /*yield*/, deleteSelectedUser(db, id, name)];
            case 4:
                _b.sent();
                _b.label = 5;
            case 5: return [2 /*return*/];
            case 6:
                err_1 = _b.sent();
                console.error(console_1["default"].red('✖') + " " + err_1.message);
                return [3 /*break*/, 7];
            case 7: return [2 /*return*/];
        }
    });
}); };
exports["default"] = Logout;
